#include <ScreenSaver.h>

const int			maxBubbles=500;

// Definition of a Bubble object
class bubble 
{
public:

	int		x;					// x-coordinate on screen
	int		y;					// y-coordinate on screen
	int		rad;				// radius of the bubble
	int		red;				// bubble-color
	int		green;
	int		blue;
	int		z;					// dept of bubble in 3d-space for sizing
	int		frac;
	int		mx;					// middle of screen
	int		my;
	bool	preview;			// for the preview-view in the screensaver-preferences
		
			bubble();			// contructor
			~bubble(){};		// destructor
	void	draw(BView *view);	// for drawing to a BView
};

bubble::bubble()				// initialize bubble
{
	x	= 0;
	y	= 0;
	mx	= 320;
	my	= 240;
	z	= rand() % 1000;
	if (rand() % 4<=3) rad = rand() % 20 + 1;
	else rad = rand() % 30 + 10;

	if (preview) rad=rand()% 10 + 1;
	
	frac= rand() %  rad + 2;
	red	= rand() % 256;
	green=rand() % 256;
	blue=rand() % 256;
}



class BeBubbles : public BScreenSaver
{

public:
	bubble		myBubble[maxBubbles];
	int			nBubbles;
	
				BeBubbles(BMessage *message, image_id id);
	void		StartConfig(BView *view);
	status_t	StartSaver(BView *v, bool preview);
	void		Draw(BView *v, int32 frame);
};
